/*
 Asalt: 100 puncte
 Implementare: Radu Costache
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

int n, m;
int xi, yi, ox, oy;

int dx[] = {1, 0, -1, 0, 1, -1, 1, -1};
int dy[] = {0, 1, 0, -1, 1, -1, -1, 1};


char v[1005][1005];
int l[1005][1005];


void Lee(int x, int y){
    int qx[1010025] = {0};
    int qy[1010025] = {0};
    qx[1] = x;
    qy[1] = y;
    l[x][y] = 1;
    int st = 1, dr = 1;
    while(st <= dr){
        x = qx[st]; int d;
        y = qy[st++];
        for(d = 0 ; d < 8 ; ++d){
            if(x + dx[d] <= 0 || y + dy[d] <= 0 || x + dx[d] > n || y + dy[d] > n)continue;

            if(v[x + dx[d]][y + dy[d]] == 1){
                FILE *g = fopen("asalt.out", "w");
                fprintf(g, "%d\n", l[x][y] + 1);
                exit(0);
            }
            else if(v[x + dx[d]][y + dy[d]] == 0 && l[x + dx[d]][y + dy[d]] == 0){
                l[x + dx[d]][y + dy[d]] = l[x][y] + 1;
                qx[++dr] = x + dx[d];
                qy[dr] = y + dy[d];
            }
        }
    }
}

int main() {
    int x;
    int y;
    int q;
    FILE *f = fopen("asalt.in", "r");

    fscanf(f, "%d %d %d\n",&n, &xi, &yi);
    fscanf(f, "%d\n", &m);
    for(int i = 1 ; i <= m ; ++i){
        fscanf(f, "%d %d\n", &x, &y);
        assert(v[x][y] == 0);
        v[x][y] = -1;
    }
    fscanf(f, "%d\n", &q);
    for(int i = 1 ; i <= q ; ++i){
        fscanf(f, "%d %d\n", &x, &y);
        assert(v[x][y] == 0);
        v[x][y] = 1;
    }
    for(int i = 1 ; i <= n ; ++i) {
        for (int j = 1; j <= n; ++j)
            printf("%d ", v[i][j]);
        printf("\n");
    }
    Lee(xi, yi);

    FILE *g = fopen("asalt.out", "w");
    fprintf(g, "-1");
    return 0;
}
