#include <bits/stdc++.h>

#pragma region TEMPLATE

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = std::pair<int, int>;
using pdd = std::pair<ld, ld>;

#define dbg(x) cerr<<#x": "<<(x)<<'\n'
#define dbg_p(x) cerr<<#x": "<<(x).first<<' '<<(x).second<<'\n'
#define dbg_v(x, n) {cerr<<#x"[]: ";for(long long _=0;_<n;++_)cerr<<(x)[_]<<' ';cerr<<'\n';}
#define all(v) v.begin(), v.end()
#define pb push_back
#define PI 3.14159265359
#define zeros(x) x&(-x)
#define fs first
#define sc second
#define pb push_back
#define oo 1000000000
#define Base 31
#define NMax 100100
#define MOD 1000000007
#define MOD2 998244353

using namespace std;

void init(){
    #ifndef ONLINE_JUDGE
		freopen("input.txt", "r", stdin); 
		freopen("output.txt", "w", stdout);
	#endif
}

#pragma endregion


struct Edge{
    int a,b,c;
};

vector<Edge> v;

int n,m,tsk,a,b,c,S;
int p[NMax];

int _find(int x){
    return p[x] ? p[x] = _find(p[x]) : x;
}

void Union(int a,int b){
    if(_find(a) != _find(b))
        p[_find(a)] = _find(b);
}

int main(){
   init();

    cin>>n>>m>>tsk;

	for(int i=1;i<=m;i++)
        cin>>a>>b>>c, v.pb({a,b,c});

    sort(all(v), [&] (Edge a, Edge b) { return a.c < b.c; });

    for(auto it : v){
        if(_find(it.a) == _find(it.b)) continue;
        Union(it.a, it.b);
        S += it.c;
    }

    if(tsk == 1) cout<<S;
    else         cout<<2*S;
    return 0;
}