//euclid+trecere in O(sqrt)+verificare in O(sqrt)
#include <fstream>
#define VALMAX 1000005

using namespace std;

ifstream fin("pilot.in");
ofstream fout("pilot.out");

int n, x, d, p, a, nrp, nrs, nrl;
int main()
{
    fin >> n >> x;
    for (int i = 1; i <= n; i++)
    {
        fin >> p >> a; // p = codul pilotului(aviatorului) si a = codul avionului
        //aflu cmmdc(p, a) pentru obtine codul spectacolului i

        int x1 = p;
        int y = a;
        int r = x1%y;
        while (r)
        {
            x1 = y;
            y = r;
            r = x1%y;
        }
        int cmmdc = y; // cmmdc este acum codul spectacolului i

        if (cmmdc % x == 0)
        {
            nrs++;	// cresc numarul de aviatori speciali
            // testez daca nu cumva acest aviator este legendar
            // determin cati divizori primi are cmmdc
            int nrdivp = 0;
            for (int j = 1; j * j <= cmmdc; j++)
            {
                // testez daca j este prim
                if (cmmdc % j == 0)
                {
                    x1 = j;
                    int ok = 1;

                    if (x1 == 0 || x1 == 1) ok = 0;
                    if(ok == 1)
                        for (int d = 2; d*d <= x1; d++)
                            if (x1 % d == 0) ok = 0;
                    nrdivp += ok;

                    // testez daca si daca cmmdc / j este prim
                    if (j != cmmdc / j)
                    {
                        int x2 = cmmdc / j;
                        ok = 1;

                        if (x2 == 0 || x2 == 1) ok = 0;
                        if(ok == 1)
                            for (int d = 2; d*d <= x2; d++)
                            {
                                if (x2 % d == 0) ok = 0;
                            }
                        nrdivp += ok;
                    }
                }
            }
            if (nrdivp == 2) nrl++;
        }
    }
    // afisez numarul de aviatori care sunt DOAR speciali
    fout << nrs << " "; // separ cele doua numere prin spatiu
    // afisez numarul de aviatori care sunt legendari
    fout << nrl << '\n';
    return 0;
}
