#include <fstream>
#include <cstring>

using namespace std;

ifstream fin ("corupte.in");
ofstream fout ("corupte.out");

struct
{
    char cuvant[105];
    int loc;
    char litera;
} sol[1006],posSol;

int  nrL, nrW, nrSol;
char s[1006], mat[1006][105], dic[1006][105];
bool switch2dictionary = false;

int main()
{
    while(fin.getline(s, 1005))
    {
        if(s[0] == '#')
        {
            switch2dictionary = true;
            continue;
        }
        if(switch2dictionary == false)
        {
            char *p=strtok(s," ");
            do
            {
                strcpy(mat[++nrL],p);
            }
            while(p=strtok(NULL, " "));
        }
        else
            strcpy(dic[++nrW], s);
    }
    for(int i = 1; i <= nrL; ++i)
    {
        posSol.loc=-1;
        for(int j = 1; j <= nrW; ++j)
        {
            if(strlen(mat[i]) != strlen(dic[j]))
                continue;
            else
            {
                int dif = 0, loc = 0;
                char litera = 0;
                for(int q = 0; mat[i][q]; ++q)
                {
                    if(mat[i][q] != dic[j][q])
                        ++dif, loc = q, litera = mat[i][q];
                    if(dif > 1)
                        break;
                }
                if(dif == 1)
                    strcpy(posSol.cuvant, dic[j]), posSol.loc = loc, posSol.litera = litera;
                else if(dif==0)
                {
                    posSol.loc=-1;
                    break;
                }
            }
        }
        if(posSol.loc!=-1)
        {
            strcpy(sol[++nrSol].cuvant, posSol.cuvant), sol[nrSol].loc = posSol.loc, sol[nrSol].litera = posSol.litera;
        }
    }
    for(int i = 1; i <= nrSol; ++i)
        fout << sol[i].cuvant << ' ' << sol[i].loc << ' ' << sol[i].litera << '\n';

    return 0;
}
