#include <fstream>
#include <cmath>
using namespace std;
ofstream fout("loto.out");
ifstream fin("loto.in");

bool c[1000010];
int p[100000];

void ciur(){
    c[0] = c[1] = 1;
    int k = 0;
    for(int i = 2; i <= 1000000; i++){
        if(!c[i]){
            p[++k] = i;
            for(long long j = 1LL * i * i; j <= 1000000; j += i) c[j] = 1;
        }
    }
}

int main()
{
    int n;
    fin >> n;
    ciur();

    bool ok = 0;

    for(int i = 1; i <= n; i++){
        long long x;
        fin >> x;

        int k = 1;
        long long d = p[k];
        long double aux = sqrt(x);

        long long rad;
        if(aux == (long long)aux) rad = (long long)aux;
        else rad = (long long)aux + 1;

        long long maxi = 0;

        while(d * d <= x){
            int pwr = 0;
            while(x % d == 0) x /= d, pwr++;

            if(pwr && d >= rad){
                maxi = max(maxi, d);
            }

            d = p[++k];
        }

        if(x != 1 && x >= rad) maxi = max(maxi, x);
        if(maxi) fout << maxi << ' ', ok = 1;
    }

    if(!ok) fout << "CATALIN RAMANE SARAC";

    return 0;
}
