#include <bits/stdc++.h>

#pragma region TEMPLATE

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = std::pair<int, int>;
using pdd = std::pair<ld, ld>;

#define dbg(x) cerr<<#x": "<<(x)<<'\n'
#define dbg_p(x) cerr<<#x": "<<(x).first<<' '<<(x).second<<'\n'
#define dbg_v(x, n) {cerr<<#x"[]: ";for(long long _=0;_<n;++_)cerr<<(x)[_]<<' ';cerr<<'\n';}
#define all(v) v.begin(), v.end()
#define pb push_back
#define PI 3.14159265359
#define zeros(x) x&(-x)
#define fs first
#define sc second
#define pb push_back
#define oo 1000000000
#define Base 31
#define NMax 100100
#define MOD 1000000007
#define MOD2 998244353

template <typename T,typename U>                                                   
std::pair<T,U> operator+(const std::pair<T,U> & l,const std::pair<T,U> & r) {   
    return {l.fs+r.fs,l.sc+r.sc};                                    
}   

using namespace std;

void init(){
    #ifndef ONLINE_JUDGE
		freopen("asalt.in", "r", stdin); 
		freopen("asalt.out", "w", stdout);
	#endif
}

#pragma endregion

int a[1010][1010];
int vis[1010][1010];

int n,k,l,c,S;
pii T;

vector<pii> dir = {{-1,-1},{-1,0},{-1,1},{0,-1},{0,1},{1,-1},{1,0},{1,1}};

bool ok(pii pos){
    return min( pos.fs, pos.sc) >= 1 &&  max(pos.fs, pos.sc) <= n && 
             a[pos.fs][pos.sc] != -1 && !vis[pos.fs][pos.sc]; 
}

int lee(pii t){
    memset(vis,0,sizeof(vis));
    queue<pii> que;
    que.push(t);
    vis[t.fs][t.sc] = 1;

    while(que.size()){
        t = que.front(); que.pop();
        if(a[t.fs][t.sc] == 1) return vis[t.fs][t.sc];
        for(pii it : dir){
            pii t2 = t + it;
            if(ok(t2))  
                vis[t2.fs][t2.sc] = vis[t.fs][t.sc] + 1, que.push(t2);
        }
    }

    return -1;
}

int main(){
    init();

    S = oo;
    cin>>n>>l>>c>>k; T = {l,c};

    for(int i=1;i<=k;i++)
        cin>>l>>c, a[l][c] = -1;
    cin>>k;
    for(int i=1;i<=k;i++)
        cin>>l>>c, a[l][c] = 1;
	
    cout<< lee(T) ;

    return 0;
}