#include <fstream>

using namespace std;
ofstream fout("john.out");
ifstream fin("john.in");

int p[10010];
int a[1010][1010];
int sum;
int k;
int n, m;
struct edge{
    int x;
    int y;
    int cost;
}edges[10000];


int parent(int x){
    return (p[x] == 0 ? x : parent(p[x]));
}

void changepar(int x, int y){
    for(int i = 1; i <= n; i++){
        if(p[i] == x) p[i] = y;
    }
}

void apm(){
    int ok;
    do{
        ok = 1;
        for(int i = 1; i < k; i++){
            if(edges[i].cost > edges[i + 1].cost) swap(edges[i], edges[i + 1]), ok = 0;
        }
    }while(!ok);

    for(int i = 1; i <= k; i++){
        int x = edges[i].x;
        int y = edges[i].y;
        int c = edges[i].cost;
        /*int par1 = parent(x);
        int par2 = parent(y);*/
        int par1 = p[x];
        int par2 = p[y];

        if(par1 != par2){
            changepar(par2, par1);
            sum += c;
        }
    }
}

int main()
{
    int t;
    fin >> n >> m >> t;

    for(int i = 1; i <= m; i++){
        int x, y, c;
        fin >> x >> y >> c;
        a[x][y] = c;
        a[y][x] = c;

        edges[++k].x = x;
        edges[k].y = y;
        edges[k].cost = c;
    }

    for(int i = 1; i <= n; i++){
        p[i] = i;
    }

    apm();

    fout << sum * t;
    return 0;
}
