// scaderi repetate+trecere in O(sqrt)+verificare in O(nr)
#include <fstream>
#define VALMAX 1000005

using namespace std;

ifstream fin("pilot.in");
ofstream fout("pilot.out");

int cmmdc_f(int, int);
int prim(int);
int n, x, d, p, a, nrp, nrs, nrl;
int main()
{
	fin >> n >> x;
	for (int i = 1; i <= n; i++) {
		fin >> p >> a; // p = codul pilotului(aviatorului) si a = codul avionului
		//aflu cmmdc(p, a) pentru obtine codul spectacolului i
		int x1 = p;
        int y = a;
        int r = x1 % y;
        while (r)
        {
            x1 = y;
            y = r;
            r = x1 % y;
        }
        int cmmdc = y;

		if (cmmdc % x == 0) {
			nrs++;	// cresc numarul de aviatori speciali
			// testez daca nu cumva acest aviator este legendar
			// determin cati divizori primi are cmmdc
			int nrdivp = 0;
			for (int j = 1; j * j <= cmmdc; j++) {
				if (cmmdc % j == 0) {
					nrdivp += prim(j);
					if (j != cmmdc / j) nrdivp += prim(cmmdc / j);
				}
			}

			if (nrdivp == 2) nrl++;
		}
	}
	// afisez numarul de aviatori care sunt DOAR speciali
	fout << nrs << " "; // separ cele doua numere prin spatiu
	// afisez numarul de aviatori care sunt legendari
	fout << nrl << '\n';
}

int cmmdc_f(int x, int y) {
	while (x != y) {
		if (x > y) x -= y;
		else y -= x;
	}
	return y;
}

int prim(int x) {
	if (x == 0 || x == 1) return 0;
	for (int d = 2; d < x; d++) {
		if (x%d == 0) return 0;
	}
	return 1;
}
