#include <fstream>
#include <iostream>
#include <cstring>
#include <algorithm>

using namespace std;

ifstream fin("cuv.in");
ofstream fout("cuv.out");

char dict[256][256];
char text[256][256];

int i = 0, n, m;
char t_c;
int t_i;
int t_j;

int exists_in_dictionary(char cuv[]) {
    for(int i = 0; i < m; i++) {
        if(strcmp(cuv, dict[i]) == 0) {
            return true;
        }
    }
    return false;
}


bool words_have_the_same_number_of_chars(char cuv1[], char cuv2[]) {
    return strlen(cuv1) == strlen(cuv2);
}

int has_error(char cuv[]) {
    if(exists_in_dictionary(cuv)) return 0;
    t_i = 0;
    t_c = ' ';
    int errors = 0;

    for(int i = 0; i < m; i++) {
        errors = 0;
        if(words_have_the_same_number_of_chars(cuv, dict[i])) {
            for(int j = 0; j < strlen(cuv); j++) {
                if(cuv[j] == dict[i][j]) {
                    continue;
                } else {
                    t_c = cuv[j];
                    t_i = i;
                    t_j = j;
                    errors ++;
                }
            }
        } else {
            continue;
        }

        if(errors == 1) {
            return 1;
        } else {
            continue;
        }
    }

    return 0;
}

int main() {
    do {
        fin >> text[i++];
    } while(text[i - 1][0] != '#');

    n = i - 1;
    i = 0;

    while(fin >> dict[i++]) {
        continue;
    }

    m = i - 1;


    for(int i = 0; i < n; i++) {
        if(has_error(text[i])) {
            fout << dict[t_i] << " " << t_j + 1 << " " << t_c << endl;
        }
    }
}